{
  This file was automatically generated on 2019-01-29.

  Delphi/Lazarus Bindings Version 2.1.23

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generators git on tinkerforge.com
}

unit BrickletRGBLED;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter, Math, SyncObjs;

const
  BRICKLET_RGB_LED_DEVICE_IDENTIFIER = 271;
  BRICKLET_RGB_LED_DEVICE_DISPLAY_NAME = 'RGB LED Bricklet';

  BRICKLET_RGB_LED_FUNCTION_SET_RGB_VALUE = 1;
  BRICKLET_RGB_LED_FUNCTION_GET_RGB_VALUE = 2;
  BRICKLET_RGB_LED_FUNCTION_GET_IDENTITY = 255;



type
  TArray0To2OfUInt8 = array [0..2] of byte;

  /// <summary>
  ///  Controls one RGB LED
  /// </summary>
  TBrickletRGBLED = class(TDevice)
  private
  protected
  public
    /// <summary>
    ///  Creates an object with the unique device ID <c>uid</c>. This object can
    ///  then be added to the IP connection.
    /// </summary>
    constructor Create(const uid__: string; ipcon_: TIPConnection);

    /// <summary>
    ///  Sets the *rgb* value for the LED. The value can be between 0 and 255.
    /// </summary>
    procedure SetRGBValue(const r: byte; const g: byte; const b: byte); virtual;

    /// <summary>
    ///  Returns the *rgb* value of the LED as set by <see cref="BrickletRGBLED.TBrickletRGBLED.SetRGBValue"/>.
    /// </summary>
    procedure GetRGBValue(out r: byte; out g: byte; out b: byte); virtual;

    /// <summary>
    ///  Returns the UID, the UID where the Bricklet is connected to,
    ///  the position, the hardware and firmware version as well as the
    ///  device identifier.
    ///  
    ///  The position can be 'a', 'b', 'c' or 'd'.
    ///  
    ///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
    ///  |device_identifier_constant|
    /// </summary>
    procedure GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TVersionNumber; out firmwareVersion: TVersionNumber; out deviceIdentifier: word); override;
  end;

implementation

constructor TBrickletRGBLED.Create(const uid__: string; ipcon_: TIPConnection);
begin
  inherited Create(uid__, ipcon_);
  apiVersion[0] := 2;
  apiVersion[1] := 0;
  apiVersion[2] := 0;

  responseExpected[BRICKLET_RGB_LED_FUNCTION_SET_RGB_VALUE] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_RGB_LED_FUNCTION_GET_RGB_VALUE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_RGB_LED_FUNCTION_GET_IDENTITY] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;

end;

procedure TBrickletRGBLED.SetRGBValue(const r: byte; const g: byte; const b: byte);
var request: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RGB_LED_FUNCTION_SET_RGB_VALUE, 11);
  LEConvertUInt8To(r, 8, request);
  LEConvertUInt8To(g, 9, request);
  LEConvertUInt8To(b, 10, request);
  SendRequest(request);
end;

procedure TBrickletRGBLED.GetRGBValue(out r: byte; out g: byte; out b: byte);
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RGB_LED_FUNCTION_GET_RGB_VALUE, 8);
  response := SendRequest(request);
  r := LEConvertUInt8From(8, response);
  g := LEConvertUInt8From(9, response);
  b := LEConvertUInt8From(10, response);
end;

procedure TBrickletRGBLED.GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TVersionNumber; out firmwareVersion: TVersionNumber; out deviceIdentifier: word);
var request, response: TByteArray; i: longint;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RGB_LED_FUNCTION_GET_IDENTITY, 8);
  response := SendRequest(request);
  uid := LEConvertStringFrom(8, 8, response);
  connectedUid := LEConvertStringFrom(16, 8, response);
  position := LEConvertCharFrom(24, response);
  for i := 0 to 2 do hardwareVersion[i] := LEConvertUInt8From(25 + (i * 1), response);
  for i := 0 to 2 do firmwareVersion[i] := LEConvertUInt8From(28 + (i * 1), response);
  deviceIdentifier := LEConvertUInt16From(31, response);
end;

end.
